<?php
header( 'Content-Type: application/xml' );

function generatePasswordDigest( $nonce, $created, $password ) {
  $rawDigest = base64_decode( $nonce ) . $created . $password;
  $sha1Digest = sha1( $rawDigest, true );
  $passwordDigest = base64_encode( $sha1Digest );
  return $passwordDigest;
}
// Example usage
$organization = 'WBSTEST';
$userId = 'WSIPYIPU';
$password = 'X2+Zh*#Ky=sd';
$officeId = 'NCEPF3240';
$dutyCode = 'SU';
date_default_timezone_set( "UTC" );
$UUID = vsprintf( '%s%s-%s-%s-%s-%s%s%s', str_split( bin2hex( random_bytes( 16 ) ), 4 ) );
date_default_timezone_set( 'UTC' );
$t = microtime( true );
$micro = sprintf( "%03d", ( $t - floor( $t ) ) * 1000 );
$date = new DateTime( date( 'Y-m-d H:i:s.' . $micro ) );
$timestamp = $date->format( "Y-m-d\TH:i:s" ) . $micro . 'Z';
$nonce = mt_rand( 10000000, 99999999 );
$nounce = base64_encode( $nonce );
$passSHA = base64_encode( sha1( $nonce . $timestamp . sha1( $password, true ), true ) );


$soap_xml_request = NULL;
$soap_xml_request .= "<soap:Envelope xmlns:soap='http://schemas.xmlsoap.org/soap/envelope/'>
    <soap:Header>
        <add:MessageID xmlns:add='http://www.w3.org/2005/08/addressing'>$UUID</add:MessageID>
        <add:Action xmlns:add='http://www.w3.org/2005/08/addressing'>http://webservices.amadeus.com/QDQLRQ_11_1_1A</add:Action>
        <add:To xmlns:add='http://www.w3.org/2005/08/addressing'>https://nodeD1.test.webservices.amadeus.com/1ASIWIPUIPY</add:To>
        <oas:Security xmlns:oas='http://docs.oasis-open.org/wss/2004/01/oasis-200401-wss-wssecurity-secext-1.0.xsd'>
            <oas:UsernameToken xmlns:oas1='http://docs.oasis-open.org/wss/2004/01/oasis-200401-wss-wssecurity-utility-1.0.xsd' oas1:Id='UsernameToken-1'>
                <oas:Username>$userId</oas:Username>
                <oas:Nonce EncodingType='http://docs.oasis-open.org/wss/2004/01/oasis-200401-wss-soap-message-security-1.0#Base64Binary'>$nounce</oas:Nonce>
                <oas:Password Type='http://docs.oasis-open.org/wss/2004/01/oasis-200401-wss-username-token-profile-1.0#PasswordDigest'>$passSHA</oas:Password>
                <oas1:Created>$timestamp</oas1:Created>
            </oas:UsernameToken>
        </oas:Security>
        <AMA_SecurityHostedUser xmlns='http://xml.amadeus.com/2010/06/Security_v1'>
            <UserID POS_Type='1' PseudoCityCode='$officeId' AgentDutyCode='$dutyCode' RequestorType='U'/>
        </AMA_SecurityHostedUser>
    </soap:Header>";


$soap_xml_request .= "<soap:Body>
        <Queue_List xmlns='http://xml.amadeus.com/QDQLRQ_11_1_1A'>
		<targetOffice>
        <sourceType>
            <sourceQualifier1>4</sourceQualifier1>
        </sourceType>
        <originatorDetails>
            <inHouseIdentification1>NCEPF3240</inHouseIdentification1>
        </originatorDetails>
    </targetOffice>
    <queueNumber>
        <queueDetails>
            <number>12</number>
        </queueDetails>
    </queueNumber>
    <categoryDetails>
        <subQueueInfoDetails>
            <identificationType>C</identificationType>
            <itemNumber>0</itemNumber>
        </subQueueInfoDetails>
    </categoryDetails>

</Queue_List>
    </soap:Body>
</soap:Envelope>";
$soap_xml_request = trim( $soap_xml_request );




$header_data[ 0 ] = "Content-Type: text/xml";
$header_data[ 1 ] = "SOAPAction: http://webservices.amadeus.com/QDQLRQ_11_1_1A";
$ch_request = curl_init( "https://nodeD1.test.webservices.amadeus.com" );
curl_setopt( $ch_request, CURLOPT_HTTPHEADER, $header_data );
curl_setopt( $ch_request, CURLOPT_CUSTOMREQUEST, "POST" );
curl_setopt( $ch_request, CURLOPT_RETURNTRANSFER, true );
curl_setopt( $ch_request, CURLOPT_POSTFIELDS, $soap_xml_request );
curl_setopt( $ch_request, CURLOPT_FOLLOWLOCATION, 1 );
curl_setopt( $ch_request, CURLOPT_CONNECTTIMEOUT, 0 );
curl_setopt( $ch_request, CURLOPT_TIMEOUT, 100 ); //timeout in seconds

$return = curl_exec( $ch_request );

echo $return;
exit;


?>